using SmallInjectorDemo.Interfaces;

namespace SmallInjectorDemo;

/// <inheritdoc />
/// <summary>
/// Implementation of <see cref="T:SmallInjectorDemo.IServiceOne" />.
/// </summary>
public class ServiceOne : IServiceOne
{
    private readonly IClock _clock;
    private readonly string _id;

    /// <summary>
    /// Creates a new instance of <see cref="ServiceOne"/>.
    /// </summary>
    public ServiceOne(IClock clock)
    {
        _clock = clock;
        _id = Guid.NewGuid().EncodeBase64String();
        Console.WriteLine(Helper.WriteMethodString(clock, _id));
    }

    /// <inheritdoc />
    public override string ToString() => Helper.WriteMethodString(_clock, _id);
}
